require("utils")
require("config")

data:extend(
	{
		{
			type = "technology",
			name = "cargo-rockets",
			icon = "__CargoRocket__/graphics/cargo-rockets.png",
			icon_size = 128,
			effects =
			{
				{
					type = "unlock-recipe",
					recipe = "cargo-departure",
				},
				{
					type = "unlock-recipe",
					recipe = "cargo-arrival",
				},
				{
					type = "unlock-recipe",
					recipe = "cargo-rocket-silo",
				},
			},
			prerequisites = { "rocket-silo", "circuit-network" },
			unit = {
				count = 500,
				ingredients = {
					{"science-pack-1", 1},
					{"science-pack-2", 1},
					{"science-pack-3", 1}
				},
				time = 60
			},
			order = "k-b",
		},
	}
)

--------------------------------------------------------------------------------------
-- local departure = dupli_proto( "container", "steel-chest", "cargo-departure", true )
local departure = dupli_proto( "logistic-container", "logistic-chest-requester", "cargo-departure", true )
departure.inventory_size = 50
departure.picture = 
    {
      filename = "__CargoRocket__/graphics/cargo-departure.png",
      priority = "extra-high",
      width = 38,
      height = 32,
      shift = {0.1, 0}
    }

data:extend(
	{
		departure,

		{
			type = "item",
			name = "cargo-departure",
			icon = "__CargoRocket__/graphics/cargo-departure-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "logistic-network",
			order = "b[storage]-ya",
			place_result = "cargo-departure",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "cargo-departure",
			enabled = false,
			energy_required = 0.5,
			ingredients = {
				{"steel-chest", 1},
				{"electronic-circuit", 2},
				{"advanced-circuit", 2},
			},
			result = "cargo-departure",
		},
	}
)

--------------------------------------------------------------------------------------
-- local arrival = dupli_proto( "container", "steel-chest", "cargo-arrival", true )
local arrival = dupli_proto( "logistic-container", "logistic-chest-passive-provider", "cargo-arrival", true )
arrival.inventory_size = 70
arrival.picture = 
    {
      filename = "__CargoRocket__/graphics/cargo-arrival.png",
      priority = "extra-high",
      width = 38,
      height = 32,
      shift = {0.1, 0}
    }

data:extend(
	{
		arrival,

		{
			type = "item",
			name = "cargo-arrival",
			icon = "__CargoRocket__/graphics/cargo-arrival-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "logistic-network",
			order = "b[storage]-yb",
			place_result = "cargo-arrival",
			stack_size = 50,
		},
		
		{
			type = "recipe",
			name = "cargo-arrival",
			enabled = false,
			energy_required = 0.5,
			ingredients = {
				{"steel-chest", 2},
				{"electronic-circuit", 2},
				{"advanced-circuit", 2},
			},
			result = "cargo-arrival",
		},
	}
)

local mapmark_anim =
{
	filename = "__CargoRocket__/graphics/empty.png",
	priority = "high",
	width = 0,
	height = 0,
	frame_count = 1,
	shift = {0,0},
}

-- to put a label on the map.
local mapmark = dupli_proto("train-stop","train-stop","cargo-mapmark")
mapmark.collision_box = {{0,0}, {0,0}}
mapmark.selection_box = {{0,0}, {0,0}}
mapmark.drawing_box = {{0,0}, {0,0}}
mapmark.order = "y"
mapmark.selectable_in_game = false
mapmark.tile_width = 1
mapmark.tile_height = 1
mapmark.rail_overlay_animations =
{
	north = mapmark_anim,
	east = mapmark_anim,
	south = mapmark_anim,
	west = mapmark_anim,
}
mapmark.animations =
{
	north = mapmark_anim,
	east = mapmark_anim,
	south = mapmark_anim,
	west = mapmark_anim,
}
mapmark.top_animations =
{
	north = mapmark_anim,
	east = mapmark_anim,
	south = mapmark_anim,
	west = mapmark_anim,
}

data:extend({mapmark})

--------------------------------------------------------------------------------------
local silo = dupli_proto( "rocket-silo", "rocket-silo", "cargo-rocket-silo", true )
silo.base_day_sprite.filename = "__CargoRocket__/graphics/cargo-silo-base-day.png"
silo.base_night_sprite.filename = "__CargoRocket__/graphics/cargo-silo-base-night.png"
silo.rocket_parts_required = nb_cargo_rocket_parts
silo.crafting_speed = 1
silo.fixed_recipe = "cargo-rocket-part"
silo.energy_usage = "200kW" 
silo.idle_energy_usage = "10KW"
silo.lamp_energy_usage = "10KW"
silo.active_energy_usage = "500KW"
silo.rocket_entity = "cargo-rocket-silo-rocket"

data:extend(
	{
		silo,

		{
			type = "item",
			name = "cargo-rocket-silo",
			icon = "__CargoRocket__/graphics/cargo-rocket-silo-icon.png",
			flags = {"goes-to-quickbar"},
			subgroup = "logistic-network",
			order = "b[storage]-yc",
			place_result = "cargo-rocket-silo",
			stack_size = 10,
		},
		
		{
			type = "recipe",
			name = "cargo-rocket-silo",
			enabled = false,
			energy_required = 6,
			ingredients =
			{
				{"steel-plate", 100},
				{"concrete", 100},
				{"pipe", 10},
				{"processing-unit", 20},
				{"electric-engine-unit", 20}
			},
			result = "cargo-rocket-silo",

		},
		
		{
			type = "item",
			name = "cargo-rocket-part",
			icon = "__base__/graphics/icons/rocket-part.png",
			flags = {"goes-to-main-inventory", "hidden"},
			subgroup = "intermediate-product",
			order = "n[rocket-part]",
			stack_size = 5
		},
		
		{
			type = "recipe",
			name = "cargo-rocket-part",
			energy_required = 5,
			enabled = false,
			hidden = true,
			category = "rocket-building",
			ingredients =
			{
				{"low-density-structure", 5},
				{"rocket-fuel", 5},
				{"rocket-control-unit", 5}
			},
			result= "cargo-rocket-part"
		},
	}
)

--------------------------------------------------------------------------------------
local rocket = dupli_proto( "rocket-silo-rocket", "rocket-silo-rocket", "cargo-rocket-silo-rocket", true )
rocket.rocket_sprite.filename = "__CargoRocket__/graphics/cargo-rocket.png" 
rocket.inventory_size = 0

data:extend(
	{
		rocket,
	}
)

