require("utils")
require("prototypes/styles")
require("prototypes/hotkey")

table.insert( data.raw["technology"]["automated-construction"].effects, { type = "unlock-recipe", recipe = "copy-settings-tool" } )

data:extend(
	{
		{
			-- https://wiki.factorio.com/index.php?title=Prototype/SelectionTool
			type = "selection-tool",
			name = "copy-settings-tool",
			icon = "__CopySettingsTool__/graphics/copy-settings-tool.png",
			flags = {"goes-to-quickbar"},
			subgroup = "tool",
			order = "c[automated-construction]-z[copy-settings-tool]",
			stack_size = 1,
			stackable = false,
			draw_label_for_cursor_render = true,
			-- copy mode :
			alt_selection_mode = {"matches-force", "any-entity"},
			alt_selection_color = { r = 0, g = 1, b = 0 },
			alt_selection_cursor_box_type = "copy",
			-- paste mode :
			-- selection_mode = {"matches-force", "buildable-type"},
			selection_mode = {"matches-force", "any-entity"},
			selection_color = { r = 1, g = 1, b = 0 },
			selection_cursor_box_type = "copy",
			always_include_tiles = false,
		},
		
		{
			type = "recipe",
			name = "copy-settings-tool",
			energy_required = 1,
			enabled = "false",
			ingredients = {
				{ "advanced-circuit", 1 },
			},
			result = "copy-settings-tool",
		}
	}
)
