dir = "__Factorio Directed by Michael Bay__"

-- remove dying_explosion from all entities
for a, ent_type in pairs(data.raw) do
	for a, prototype in pairs(ent_type) do
		if prototype.max_health ~= nil then
			prototype.dying_explosion = nil
		end
	end
end

-- create new explosion "tall-explosion"
data:extend({
	{
    type = "explosion",
    name = "tall-explosion",
    flags = {"not-on-map"},
    animations =
		{
			{
			filename = dir.."/graphics/waitex-medium-explosion.png",
			priority = "extra-high",
			width = 224,
			height = 188,
			frame_count = 54,
			line_length = 6,
			shift = {-1, -1.6},
			animation_speed = 0.4
			}
		},
    light = {intensity = 1, size = 50},
    sound =
		{
			{
			filename = "__base__/sound/fight/large-explosion-1.ogg",
			volume = 1
			},
			{
			filename = "__base__/sound/fight/large-explosion-2.ogg",
			volume = 1
			}
		},
    created_effect =
		{
		type = "direct",
		action_delivery =
			{
			type = "instant",
			target_effects =
				{
					{
					type = "create-particle",
					repeat_count = 10,
					entity_name = "explosion-remnants-particle",
					initial_height = 0.5,
					speed_from_center = 0.08,
					speed_from_center_deviation = 0.15,
					initial_vertical_speed = 0.08,
					initial_vertical_speed_deviation = 0.15,
					offset_deviation = {{-0.2, -0.2}, {0.2, 0.2}}
					}
				}
			}
		}
	}
})