local ticks = 0
local update_interval = 20
local find_entity_interval = 240

-- Events
script.on_event(defines.events.on_built_entity, function(event)
	EventOnEntityCreation(event)
end)

script.on_event(defines.events.on_robot_built_entity, function (event)
	EventOnEntityCreation(event)
end)

script.on_event(defines.events.on_preplayer_mined_item, function(event)
  removeItemSensor(event.entity)
end)

script.on_event(defines.events.on_robot_pre_mined, function(event)
  removeItemSensor(event.entity)
end)

script.on_event(defines.events.on_entity_died, function(event)
  removeItemSensor(event.entity)
end)

function Dfunc(msg)
	for _,player in pairs(game.players) do
		player.print(msg)
    end
end
script.on_event(defines.events.on_train_changed_state, function(event)
	local diffx 
	local diffy
	--if event.entity.type == "cargo-wagon" then
	if event.train.state == defines.train_state.wait_station or 
		event.train.state == defines.train_state.wait_signal or 
		event.train.state == defines.train_state.manual_control then --not sure if manual will work, NOT ANYMORE !
		for j, carriage in ipairs(event.train.carriages) do
			if carriage.get_inventory(1) ~= nil and carriage.type == "cargo-wagon" then
				--vallid Cargo wagon
				-- check if in range off sensor
				ConnectDetectablEntity(carriage)
			end
		end
	else --train moves disconnect from sensor
		--loop thru all sensors and remove the train(+cargo-wagon).
		for i, itemSensor in ipairs(global.ItemSensors) do
			for j, carriage in ipairs(event.train.carriages) do
				if itemSensor.connectedEntity==carriage then
					itemSensor.connectedEntity=nil
					itemSensor.Sensor.get_control_behavior().parameters = nil
				end
			end
		end
	end
end)
script.on_event(defines.events.on_tick, function(event)
	if event.tick % 20 == 0 then
		for i, itemSensor in ipairs(global.ItemSensors) do
			--itemSensor.connectedEntity = getConnectedEntity(itemSensor.Sensor)
			setInventoryNEW(itemSensor.Sensor, itemSensor.connectedEntity)
		end
	end
end)
function EventOnEntityCreation(event)
	--Dfunc("Possible Detectable Item placed: "..event.created_entity.name)
	if (event.created_entity.name == "SBIG-Inventory-Sensor") then
		disableOperableIfSensor(event.created_entity)
		addSensorToTable(event.created_entity)
		-- one time detection the old fashion way
		local tmpentity = getConnectedEntity(event.created_entity)
		if tmpentity ~= nil then
			ConnectDetectablEntity(tmpentity)
		end
	end
	if (event.created_entity.type == "furnace" or event.created_entity.type == "assembling-machine" or event.created_entity.type == "cargo-wagon") then
		ConnectDetectablEntity(event.created_entity)
	end
end

function ConnectDetectablEntity(entity)
	for i, itemSensor in ipairs(global.ItemSensors) do
		diffx=itemSensor.Sensor.position.x-entity.position.x
		diffy=itemSensor.Sensor.position.y-entity.position.y
		if diffx>= -3 and diffx<= 3 and diffy>= -3 and diffy<= 3 then
			itemSensor.connectedEntity = entity
			--Dfunc("Sensor "..i..": "..entity.name)
		end
	end
end

function add_inv_to_inv(inv, inv2)
	if inv2 ~= nil then
		--Dfunc("call add_inv_to_inv")
		local contentsTable = inv2.get_contents()
		if contentsTable ~= nil then
			--Dfunc("  contentsTable exist")
			for k,v in pairs(contentsTable) do
				--Dfunc ("  " .. k .. ": " .. v)
				local existing = inv[k]
				if existing == nil then 
					inv[k] = v 
				else
					inv[k] = existing + v
				end
			end
		end
	end
	return inv
end

function setInventoryNEW(sensor, connectedEntity)
	local inventory = {}
	
	-- return empty inventory
	if connectedEntity ==nil or not connectedEntity.valid then
		sensor.get_control_behavior().parameters = nil
		return
	else
		--Dfunc("Update Sensor: "..connectedEntity.type)
		if connectedEntity.type == "locomotive" or connectedEntity.type == "assembling-machine" or connectedEntity.type == "furnace" then
			for i=1, 4, 1 do --in case some mod adds cargo inventory to locomotives
				inventory = add_inv_to_inv(inventory, connectedEntity.get_inventory(i))
			end
		end
		if connectedEntity.type == "cargo-wagon" then
			inventory = add_inv_to_inv(inventory, connectedEntity.get_inventory(1))
		end
	end
	-- copy inventory to constant combinator parameters	
	--Dfunc("Output !")
	local ccParameter={}
	local signalIndex=0
	for k,v in pairs(inventory) do
		--Dfunc ("  " .. k .. ": " .. v)
		signalIndex = signalIndex+1
		table.insert(ccParameter, {index=signalIndex,signal={type="item",name=k},count=v})
	end
	params = {parameters=ccParameter}
	sensor.get_control_behavior().parameters = params	
end









script.on_init(function()
  onLoad()
end)

script.on_load(function()
  onLoad()
end)

function onLoad()
	if not global.ItemSensors then
		global.ItemSensors = {}
	end		
end

-- Logic

function disableOperableIfSensor(entity)
	entity.operable = false
end

function addSensorToTable(entity)
	local itemSensor = {Sensor=entity, Connected=nil}
	table.insert(global.ItemSensors, itemSensor)
end

-- returns first found connectable entity
function getConnectedEntity(sensor)
	local connectedEntities = sensor.surface.find_entities({{x = sensor.position.x - 3, y = sensor.position.y - 3}, {x = sensor.position.x + 3, y = sensor.position.y + 3}})
	for _,entity in ipairs(connectedEntities) do
		if (entity.valid and (entity.type == "furnace" or entity.type == "assembling-machine" or entity.type == "locomotive" or entity.type == "cargo-wagon")) then
			return entity
		end
	end
end

function removeItemSensor(entity)
  for i, itemSensor in ipairs(global.ItemSensors) do
    if notNil(itemSensor.Sensor, "position") then
      if itemSensor.Sensor.position.x == entity.position.x and itemSensor.Sensor.position.y == entity.position.y then
        table.remove(global.ItemSensors,i)
        break
      end
    end
  end
end

function notNil(class, var)
  value = false
  pcall(function()
    if class[var] then
      value = true
    end
  end)
  return value
end

function setInventory(sensor, connectedEntity)
	local inventory = {}
	
	-- return empty inventory
	if connectedEntity ==nil then
		sensor.get_control_behavior().parameters = nil
		return
	end
	
	if not connectedEntity.valid then
		sensor.get_control_behavior().parameters = nil
		return	
	end

	-- get locomotive inventory
	if connectedEntity.type == "locomotive" then
		if connectedEntity.train.state == defines.train_state.wait_station or 
		  connectedEntity.train.state == defines.train_state.wait_signal or 
		  connectedEntity.train.state == defines.train_state.manual_control then --not sure if manual will work
			for i=1, 4, 1 do --in case some mod adds cargo inventory to locomotives
				if connectedEntity.get_inventory(i) ~= nil then
					local contentsTable = connectedEntity.get_inventory(i).get_contents()
					for k,v in pairs(contentsTable) do
						inventory = add_detected_items(inventory, k, v)						
					end		  
				end
			end
		else -- train is moving > remove connection
			connectedEntity = nil
			sensor.get_control_behavior().parameters = nil
			return
		end
	end
	
	-- get traincar inventory
	if connectedEntity.type == "cargo-wagon" then
		if connectedEntity.train.state == defines.train_state.wait_station or 
		  connectedEntity.train.state == defines.train_state.wait_signal or 
		  connectedEntity.train.state == defines.train_state.manual_control then --not sure if manual will work
			if connectedEntity.get_inventory(1) ~= nil then
				local contentsTable = connectedEntity.get_inventory(1).get_contents()
				for k,v in pairs(contentsTable) do
					inventory = add_detected_items(inventory, k, v)						
				end		  
			end
		else -- train is moving > remove connection
			connectedEntity = nil
			sensor.get_control_behavior().parameters = nil
			return
		end
	end

	-- get assembler inventory
	if connectedEntity.type == "assembling-machine" then
		for i=1, 4, 1 do --really no idea what inventories assemblers can have
			if connectedEntity.get_inventory(i) ~= nil then
				local contentsTable = connectedEntity.get_inventory(i).get_contents()
				for k,v in pairs(contentsTable) do
					inventory = add_detected_items(inventory, k, v)						
				end		  
			end
		end
	end
	
	-- get furnace inventory
	if connectedEntity.type == "furnace" then
		for i=1, 4, 1 do
			if connectedEntity.get_inventory(i) ~= nil then
				local contentsTable = connectedEntity.get_inventory(i).get_contents()
				for k,v in pairs(contentsTable) do
					inventory = add_detected_items(inventory, k, v)						
				end		  
			end
		end
	end

	-- copy inventory to constant combinator parameters	
	local ccParameter={}
	local signalIndex=0
	for k,v in pairs(inventory) do
		signalIndex = signalIndex+1
		table.insert(ccParameter, {index=signalIndex,signal={type="item",name=k},count=v})
	end
	params = {parameters=ccParameter}
	sensor.get_control_behavior().parameters = params	
end

function add_detected_items(inv, itemName, itemCount)
	local existing = inv[itemName]
	if existing == nil then 
		inv[itemName] = itemCount 
	else
		inv[itemName] = existing + itemCount
	end
	return inv
end